##
##  apache-openid.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         apache-openid
Summary:      Apache Extension: OpenID Authentication
URL:          http://trac.butterfat.net/public/mod_auth_openid
Vendor:       Bufferfat, LLC
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Web
License:      Open Source
Version:      20100110
Release:      20100110

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/apache-openid/mod_auth_openid-%{version}.tar.gz
Source1:      apache-openid.conf
Patch0:       apache-openid.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, apache, autoconf, libtool, make, pkgconfig
PreReq:       OpenPKG, openpkg >= 20160101, apache
BuildPreReq:  libopkele, sqlite, pcre, curl, tidy
PreReq:       libopkele, sqlite, pcre, curl, tidy

%description
    This is the OpenID extension module for the Apache HTTP webserver.

%track
    prog apache-openid = {
        version   = %{version}
        url       = http://trac.butterfat.net/public/mod_auth_openid/wiki/Releases
        regex     = mod_auth_openid-(__VER__)\.tar\.gz
    }

%prep
    %setup -q -n mod_auth_openid
    %patch -p0

%build
    ./autogen.sh >/dev/null 2>&1
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O}" \
    CPPFLAGS="%{l_cppflags}" \
    LDFLAGS="%{l_ldflags}" \
    LIBS="-lopkele -lsqlite3 -ltidy -lcrypto -lstdc++" \
    AUTOCONF="true" \
    ACLOCAL="true" \
    AUTOHEADER="true" \
    AUTOMAKE="true" \
    ./configure \
        --prefix=%{l_prefix} \
        --with-apxs=%{l_prefix}/sbin/apxs \
        --with-apr-config=%{l_prefix}/bin/apr-1-config \
        --with-pcre=%{l_prefix} \
        --with-sqlite3=%{l_prefix}
    %{l_make} %{l_mflags -O}

%install
    #   install module
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/apache/apache.d \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/apache
    %{l_shtool} install -c -m 755 \
        .libs/mod_auth_openid.so \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/apache/mod_auth_openid.so
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE apache-openid.conf} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/apache/apache.d/

    #   create directories for database
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/var/apache-openid

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/apache/apache.d/apache-openid.conf' \
        '%config %{l_prefix}/etc/apache-openid/*' \
        '%dir %attr(-,%{l_nusr},%{l_ngrp}) %{l_prefix}/var/apache-openid'

%files -f files

%clean

%post
    #   on initial installation, create database
    if [ $1 -eq 1 ]; then
        $RPM_INSTALL_PREFIX/bin/sqlite3 \
            $RPM_INSTALL_PREFIX/var/apache-openid/mod_auth_openid.db \
            "VACUUM" </dev/null
        chown %{l_nusr}:%{l_ngrp} \
            $RPM_INSTALL_PREFIX/var/apache-openid/mod_auth_openid.db >/dev/null 2>&1 || true
        chmod 660 \
            $RPM_INSTALL_PREFIX/var/apache-openid/mod_auth_openid.db >/dev/null 2>&1 || true
    fi

    #   after upgrade, restart service
    [ $1 -eq 2 ] || exit 0
    eval `%{l_rc} apache status 2>/dev/null`
    [ ".$apache_active" = .yes ] && %{l_rc} apache restart
    exit 0

%preun
    #   on uninstallation, delete database
    if [ $1 -eq 0 ]; then
        rm -f $RPM_INSTALL_PREFIX/var/apache-openid/mod_auth_openid.db >/dev/null 2>&1 || true
    fi

